import io

import yaml


class ServerConfig:
    def __init__(self, config_yaml):
        with io.open(config_yaml, 'r', encoding='utf8') as yaml_file:
            self.server_params = yaml.safe_load(yaml_file)
        yaml_file.close()

    def get(self, config_id):
        if config_id in self.server_params:
            return self.server_params[config_id]
        else:
            raise ValueError
