from deploy.server.base.port_listener import SinglePortListener
from misc_util.logged_object import LoggedObject
from misc_util.timer import Timer


class InferenceServer(LoggedObject, SinglePortListener):
    def __init__(self, open_ports=None, name="inference server", do_logging=False):
        LoggedObject.__init__(self, do_logging=do_logging)
        SinglePortListener.__init__(self, open_ports)
        self.logger.debug("Listening on Port {}".format(open_ports[0]))
        self.name = name
        return

    def _run_inner_loop(self):
        return

    def run(self):
        frame_timer = Timer(verbose=False)
        frame_count = 0
        loop_ok = True
        while loop_ok:
            self.logger.info("Frame {}".format(frame_count))
            frame_timer.start("")

            loop_ok = self._run_inner_loop()

            frame_time = frame_timer.stop()
            self.logger.info("Frame time: {}".format(frame_time))
            frame_count += 1
        return
