import json
import os

from config.model_config import ModelConfig


def create_model_config_from_train_config(train_config):
    model_config_yaml = train_config.get('model_config')
    model_config = ModelConfig(model_config_yaml)
    return model_config


def get_files_and_keypoints(annotation_json, dataset_dir=None):
    image_filenames = []
    annotations = []
    if os.path.isfile(annotation_json):
        json_data = read_json(annotation_json)
        if dataset_dir is None:
            datadir = json_data['dataset_dir']
        else:
            datadir = dataset_dir
        image_filenames = []
        annotations = []
        if os.path.isdir(datadir):
            for elem in json_data:
                if elem != "dataset_dir":
                    image_filenames.append(os.path.join(datadir, elem))
                    annotations.append(json_data[elem])

        else:
            print("Directory given in json file does not exist.")
    else:
        print("File given does not exist.")
    return image_filenames, annotations


def save_json(data, path):
    json_content = json.dumps(data)
    with open(path, 'w') as json_file:
        json_file.write(json_content)
    json_file.close()


def read_json(path):
    with open(path, 'r') as json_file:
        json_data = json.load(json_file)
    json_file.close()
    return json_data
