import numpy as np
import tensorflow as tf
from tensorflow.python.keras.models import load_model


def is_none_keypoint(keypoint):
    return np.array_equal(keypoint, make_none_keypoint())


def make_none_keypoint():
    return [-1, -1]


# keypoints only get rescaled if they are not denoted as non existent (-1, -1)
def rescale_keypoint(keypoint, from_width, from_height, to_width, to_height):
    if not is_none_keypoint(keypoint):
        return [keypoint[0] / from_width * to_width, keypoint[1] / from_height * to_height]
    else:
        return make_none_keypoint()


def create_model_from_weights(run_id, weights):
    tf.print("Creating {} model ...".format(run_id))
    my_model = load_model(weights)
    my_model.trainable = False
    return my_model
