from research.ablation_studies.dataset.dataset_utils import gather_tfrecords, sequence_image_feature_description, \
    prepare_dataset

if __name__ == '__main__':
    tfrecord_dir = "/home/florin/data/sequence/"
    # tfrecord_dir = "/home/florin/glowing-keypoint-firefly-dep/research/ablation_studies/sequence/"
    tfrecords = gather_tfrecords(tfrecord_dir=tfrecord_dir)
    # tfrecords = ["/home/florin/data/sequence/todo_s26_t4_sequences.tfrecord"]

    dataset_in = iter(prepare_dataset(tfrecords, sequence_image_feature_description))

    val_count = 0
    train_count = 0
    test_subjects = [0, 6, 10, 14, 20, 23, 38, 39]
    dict_count = {}
    val_down_count = 0
    train_down_count = 0
    val_up_count = 0
    train_up_count = 0

    for item in dataset_in:
        if int(item['image/frame_id']) == -1:
            print("ALERT")
            print(item['image/subject_id'])
            print(item['image/task_id'])
            print(item['image/frame_id'])
            print(item['image/ptip_x'])
            print(item['image/ptip_y'])
        if item['image/subject_id'] in test_subjects:
            val_count += 1
            if int(item['image/pen_down']) == 0:
                val_up_count += 1
            else:
                val_down_count += 1
        else:
            train_count += 1
            if int(item['image/pen_down']) == 0:
                train_up_count += 1
            else:
                train_down_count += 1
        if int(item['image/subject_id']) not in dict_count:
            dict_count[int(item['image/subject_id'])] = 1
        else:
            dict_count[int(item['image/subject_id'])] += 1

    print("Val count {}".format(val_count))
    print("Train count {}".format(train_count))

    print("Val pen UP (Negatives) count {}".format(val_up_count))
    print("Val pen DOWN (Positives) count {}".format(val_down_count))
    print("Train pen UP (Negatives) count {}".format(train_up_count))
    print("Val pen DOWN (Positives) count {}".format(train_down_count))

    print(dict_count)
