import os
import time

import numpy as np
import tensorflow as tf
from tensorflow.python.keras.models import load_model

if __name__ == '__main__':
    # model_weights = "/home/florin/diss_models/final_weights/kp/detail/effnet-b0/effnetb0_detail_u4_ff_ra9_best.187.h5"
    model_weights = "/home/florin/diss_models/effnetb0_classify_rnn_diss_conv/rnn_ab2_ts30_shift30_convlstm64_7dtbnf_normlr3_aug_adam/1_chkpt/rnn_ab2_ts30_shift30_convlstm64_7dtbnf_normlr3_aug_adam_best.002.h5"
    my_model = load_model(model_weights)
    my_model.summary()

    image_dir = "/home/florin/data/patches_224/test/"
    image_files = os.listdir(image_dir)
    image_files = [file for file in image_files if '.jpg' in file]

    count = 0
    time_sum = 0
    print("Starting...")

    my_sequence = image_files[:30]
    my_input = np.zeros(shape=(1, 30, 224, 224, 3))
    for index, image_file in enumerate(my_sequence):
        image = tf.io.read_file(os.path.join(image_dir, image_file))
        image = tf.image.decode_jpeg(image)
        image = tf.image.convert_image_dtype(image, tf.float32)
        my_input[0, index, :, :, :] = image

    print("Loaded Sequence ...")

    print(my_input.shape)
    before = time.perf_counter()
    output = my_model([my_input])
    difference = time.perf_counter() - before

    print(difference)

    print("++++++++++++++++++++++")
    print(time_sum)
    print(count)
    print(time_sum / count)
