import lorem
import numpy as np
import tensorflow as tf
from PIL import ImageFont, ImageDraw


def encode_and_write_float_img(filename, image):
    tf.debugging.assert_type(image, tf.float32)
    output_image = tf.clip_by_value(image, 0.0, 1.0)
    output_image = tf.image.convert_image_dtype(output_image, tf.uint8)
    output_image = tf.io.encode_jpeg(output_image, chroma_downsampling=False)
    tf.io.write_file(filename, output_image)
    return


def write_loremipsum_on_image(image, randomize=False):
    text_size = (32 + int(np.random.uniform(-5, 5))) if randomize else 32
    fnt = ImageFont.truetype("Pillow/Tests/fonts/FreeMono.ttf", text_size)
    # get a drawing context
    d = ImageDraw.Draw(image)

    # draw multiline text
    text = ('\n').join(lorem.paragraph().split('.'))

    random_color = (int(np.random.uniform(0, 128)),
                    int(np.random.uniform(0, 128)),
                    int(np.random.uniform(0, 128)))
    color = random_color if randomize else (0, 0, 0)
    d.multiline_text((-20, 10), text, font=fnt, fill=color)
    return image
