import os

from research.ablation_studies.train.model_keypoint_trainer import ModelKeypointTrainer


def train_arch(arch, ds_train, ds_test, model, train_prefix_id, batch_size, epochs):
    model_save_path = "/home/florin/diss_models/{}/{}/1/".format(arch, train_prefix_id)
    os.makedirs(model_save_path, exist_ok=True)
    print("Storing model in {}".format(model_save_path))

    checkpoint_save_path = "/home/florin/diss_models/{}/{}/1_chkpt/".format(arch, train_prefix_id)
    os.makedirs(checkpoint_save_path, exist_ok=True)
    print("Storing checkpoints in {}".format(checkpoint_save_path))

    trainer = ModelKeypointTrainer(ds_train, ds_test, batch_size, model, train_prefix_id, checkpoint_save_path)
    print("Initial loss and MSE")
    # trainer.validate(20)

    print("Starting training!")
    trainer.train(epochs)

    print("Saving model ...")

    model.save(model_save_path, save_format='tf')
    return
