import numpy as np

from applications.brokers.kbt_inference_broker import KeypointBinarizationTipletBroker
from applications.network_utils import receive_image


class KeypointBinarizationTipletClientPatchBroker(KeypointBinarizationTipletBroker):
    def _get_tiplet_from_camera_image(self, tip, full_size_image):
        self._get_open_port_socket().send_data(np.array(tip), "tip_keypoint", compressed=False)
        msg, patch = receive_image(self._get_open_port_socket(), comp_method='pil')
        assert (msg == "fine_patch")
        return patch


if __name__ == "__main__":
    inference_servers = ['tcp://127.0.0.1:60000',
                         'tcp://127.0.0.1:60001']

    server_bin_key_tiplet_client_patch = KeypointBinarizationTipletClientPatchBroker(
        patch_size=32,
        validate=False,
        open_ports=['tcp://*:19858'],
        inference_servers_parallel=inference_servers,
        inference_servers_seq=['tcp://127.0.0.1:60003'],
        name="kbt_broker",
        do_logging=True)

    server_bin_key_tiplet_client_patch.run()
