from applications.logged_object import LoggedObject
from util.network.bidirectional_imagezmq import ZMQHubFactory
from util.timer import Timer


class InferenceClient(LoggedObject):
    def __init__(self, server_address, compressed_send=False, no_decoding=False, do_logging=False):
        super().__init__(do_logging=do_logging)
        self.logger.debug("Instantiating Inference Client with server address {}".format(server_address))
        self.client_socket = ZMQHubFactory.get_REQ(server_address)
        self.compressed_send = compressed_send
        self.no_decoding = no_decoding
        self.timer = Timer(verbose=False)
        return

    def _run_inner_loop(self):
        return

    def run(self):
        frame_timer = Timer(verbose=False)
        frame_count = 0
        loop_ok = True
        while loop_ok:
            self.logger.info("Frame {}".format(frame_count))
            frame_timer.start("")

            loop_ok = self._run_inner_loop()

            frame_time = frame_timer.stop()
            self.logger.info("Frame time: {}".format(frame_time))
            frame_count += 1
        return
