import matplotlib
import numpy as np

matplotlib.use('TkAgg')
import matplotlib.pyplot as plt

# scale_factor = 224/211
# inds = np.array(list(np.ndindex(211,211))).astype('float32')
# inds *= scale_factor

# min_distances = []
# for i in range(1000):
#     tip_x, tip_y = np.trunc(np.random.uniform(0, 224, 2))
#
#     #print("tip {}/{}".format(tip_x, tip_y))
#     #print("heatmap {}".format(tip_x, tip_y))
#     min_distances.append(min(np.linalg.norm(inds - (tip_x, tip_y), axis=1)))
#
# min_distances = np.array(min_distances)
# print(np.mean(min_distances))
# print(np.std(min_distances))
# print(np.median(min_distances))
scale_factor = 224 / 211
indices_hm = list(np.ndindex(211, 211))
list_x, list_y = zip(*indices_hm)
scaled_x_floored = np.floor(np.array(list_x) * scale_factor)
scaled_y_floored = np.floor(np.array(list_y) * scale_factor)
scaled_x = np.array(list_x) * scale_factor
scaled_y = np.array(list_y) * scale_factor

dx = scaled_x - scaled_x_floored
dy = scaled_y - scaled_y_floored
distances = np.sqrt(dx * dx + dy * dy)
print(np.mean(distances))

indices_patch = list(np.ndindex(224, 224))
list_patch_x, list_patch_y = zip(*indices_patch)

fig, ax = plt.subplots()
ax.plot(scaled_x, scaled_y, marker='x', color='b', linestyle='none')
ax.plot(scaled_x_floored, scaled_y_floored, marker='.', color='k', linestyle='none')
ax.plot(11, 17, marker='o', color='g', linestyle='none')
ax.set_aspect('equal', 'box')
ax.set_ylim(ax.get_ylim()[::-1])
plt.show()
