import os


def make_subject_base_path(study_base_path, id):
    return os.path.join(study_base_path, "videos/P{}/".format(id + 1))


###############################################################################

val2_study_base_path = "L:/validation_study_2/"

native_rotation_prefix = "val2_accuracy_"
angle_rotation_prefix = "val2_accuracy_angle_"
angle_rotation_nr_prefix = "val2_accuracy_angle_nr_"
angle_rotation_nr_crop_history_prefix = "val2_accuracy_angle_nr_crop_history_"

val2_subjects = {
    0: {  # P1
        "name": "P1",
        "path": make_subject_base_path(val2_study_base_path, 0),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 0), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 0), "rot270"),
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 0),
                                                    "rot270_nr_crop_history"),
        "step": 4,
        "res": (1920, 1080),
        "scale_factor": (1, 1),
        "angle_cw": 90,
        "count": 246,
        "actual_count": 246
    },
    1: {  # P2
        "name": "P2",
        "path": make_subject_base_path(val2_study_base_path, 1),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 1), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 1), "rot270"),
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 1),
                                                    "rot270_nr_crop_history"),
        "step": 9,
        "res": (848, 480),
        "scale_factor": (0.442, 0.444),
        "angle_cw": 90,
        "count": 219
    },
    2: {  # P3
        "name": "P3",
        "path": make_subject_base_path(val2_study_base_path, 2),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 2), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 2), "native_rotation"),
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 2), "native_rotation"),
        "step": 4,
        "res": (1080, 720),
        "scale_factor": (0.563, 0.666),
        "angle_cw": 0,
        "count": 227,
        "actual_count": 224
    },
    3: {  # P4
        "name": "P4",
        "path": make_subject_base_path(val2_study_base_path, 3),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 3), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 3), "rot270"),  # equals 90 deg cw
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 3),
                                                    "rot270_nr_crop_history"),
        "step": 2,
        "res": (640, 352),
        "scale_factor": (0.333, 0.326),
        "angle_cw": 90,
        "count": 203
    },
    4: {  # P5
        "name": "P5",
        "path": make_subject_base_path(val2_study_base_path, 4),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 4), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 4), "native_rotation"),
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 4), "native_rotation"),
        "step": 4,
        "res": (1920, 1080),
        "scale_factor": (1, 1),
        "angle_cw": 0,
        "count": 213,
        "actual_count": 211
    },
    5: {  # P6
        "name": "P6",
        "path": make_subject_base_path(val2_study_base_path, 5),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 5), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 5), "rot270"),  # equals 90 deg cw
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 5),
                                                    "rot270_nr_crop_history"),
        "step": 3,
        "res": (1280, 720),
        "scale_factor": (0.667, 0.667),
        "angle_cw": 90,
        "count": 242,
        "actual_count": 238
    },
    6: {  # P7
        "name": "P7",
        "path": make_subject_base_path(val2_study_base_path, 6),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 6), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 6), "rot270"),
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 6),
                                                    "rot270_nr_crop_history"),
        "step": 3,
        "res": (1920, 1080),
        "scale_factor": (1, 1),
        "angle_cw": 90,
        "count": 248,
        "actual_count": 248
    },
    7: {  # P8
        "name": "P8",
        "path": make_subject_base_path(val2_study_base_path, 7),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 7), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 7), "rot90"),
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 7),
                                                    "rot90_nr_crop_history"),
        "step": 2,
        "res": (1920, 1080),
        "scale_factor": (1, 1),
        "angle_cw": 270,
        "count": 286,
        "actual_count": 284
    },
    8: {  # P9
        "name": "P9",
        "path": make_subject_base_path(val2_study_base_path, 8),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 8), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 8), "rot270"),  # equals 90 deg cw
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 8),
                                                    "rot270_nr_crop_history"),
        "step": 6,
        "res": (1920, 1080),
        "scale_factor": (1, 1),
        "angle_cw": 90,
        "count": 209,
        "actual_count": 207
    },
    9: {  # P10
        "name": "P10",
        "path": make_subject_base_path(val2_study_base_path, 9),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 9), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 9), "rot270"),
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 9),
                                                    "rot270_nr_crop_history"),
        "step": 7,
        "res": (1920, 1080),
        "scale_factor": (1, 1),
        "angle_cw": 90,
        "count": 203,
        "actual_count": 201
    },
    10: {  # P11
        "name": "P11",
        "path": make_subject_base_path(val2_study_base_path, 10),
        "path_acc": os.path.join(make_subject_base_path(val2_study_base_path, 10), "native_rotation"),
        "path_acc_angle": os.path.join(make_subject_base_path(val2_study_base_path, 10), "rot90"),
        "path_acc_angle_crop_history": os.path.join(make_subject_base_path(val2_study_base_path, 10),
                                                    "rot90_nr_crop_history"),
        "step": 28,
        "res": (640, 352),
        "scale_factor": (0.333, 0.326),
        "angle_cw": 270,
        "count": 205
    }
}
