from util.network.bidirectional_imagezmq import ZMQHubFactory


class PortListener():
    def __init__(self, open_ports=None):
        self.open_ports = open_ports
        self.open_port_sockets = {}
        self._prepare_open_ports()
        return

    def _prepare_open_ports(self):
        for port in self.open_ports:
            self.open_port_sockets[port] = ZMQHubFactory.get_REP(port)
            # self.logger.info("Opened socket listening on port {}".format(port))
        return


class SinglePortListener(PortListener):
    def __init__(self, open_port=None):
        super().__init__(open_ports=open_port)
        assert (len(list(self.open_port_sockets.values())) == 1)

    def _get_open_port_socket(self):
        ports = list(self.open_port_sockets.values())
        return ports[0]
