import json
import sys

import pygame as pg
from watchdog.events import FileSystemEventHandler

from applications.text_viewer.ink_response_parser import InkResponseParser
from dataset_utils import save_json

ink_json = {"recognitionUnits": [{"alternates": [{"category": "inkWord", "recognizedString": "The"},
                                                 {"category": "inkWord", "recognizedString": "she"},
                                                 {"category": "inkWord", "recognizedString": "She"},
                                                 {"category": "inkWord", "recognizedString": "rhe"},
                                                 {"category": "inkWord", "recognizedString": "Fie"},
                                                 {"category": "inkWord", "recognizedString": "Fee"},
                                                 {"category": "inkWord", "recognizedString": "Tie"},
                                                 {"category": "inkWord", "recognizedString": "Tee"},
                                                 {"category": "inkWord", "recognizedString": "Jhe"}],
                                  "boundingRectangle": {"height": 51.130001068115234, "topX": 598.1400146484375,
                                                        "topY": 541.66998291015625, "width": 79}, "category": "inkWord",
                                  "class": "leaf", "id": 4, "parentId": 3, "recognizedText": "the",
                                  "rotatedBoundingRectangle": [{"x": 596.58001708984375, "y": 570.02001953125},
                                                               {"x": 656.6300048828125, "y": 518.010009765625},
                                                               {"x": 686.6199951171875, "y": 552.6300048828125},
                                                               {"x": 626.57000732421875, "y": 604.6400146484375}],
                                  "strokeIds": [0, 1]}, {
                                     "alternates": [{"category": "inkWord", "recognizedString": "would"},
                                                    {"category": "inkWord", "recognizedString": "wired"},
                                                    {"category": "inkWord", "recognizedString": "worlds"},
                                                    {"category": "inkWord", "recognizedString": "wold"},
                                                    {"category": "inkWord", "recognizedString": "trad"},
                                                    {"category": "inkWord", "recognizedString": "irah"},
                                                    {"category": "inkWord", "recognizedString": "trodd"},
                                                    {"category": "inkWord", "recognizedString": "hodd"},
                                                    {"category": "inkWord", "recognizedString": "hah"}],
                                     "boundingRectangle": {"height": 82.339996337890625, "topX": 693.280029296875,
                                                           "topY": 439.33999633789063, "width": 84.019996643066406},
                                     "category": "inkWord", "class": "leaf", "id": 5, "parentId": 3,
                                     "recognizedText": "world",
                                     "rotatedBoundingRectangle": [{"x": 677.53997802734375, "y": 492.35000610351563},
                                                                  {"x": 747.65997314453125, "y": 431.6099853515625},
                                                                  {"x": 777.280029296875, "y": 465.80999755859375},
                                                                  {"x": 707.15997314453125, "y": 526.54998779296875}],
                                     "strokeIds": [2, 3, 4]}, {
                                     "alternates": [{"category": "inkWord", "recognizedString": "8"},
                                                    {"category": "inkWord", "recognizedString": "08"},
                                                    {"category": "inkWord", "recognizedString": "do"},
                                                    {"category": "inkWord", "recognizedString": "So"},
                                                    {"category": "inkWord", "recognizedString": "os"},
                                                    {"category": "inkWord", "recognizedString": "888"},
                                                    {"category": "inkWord", "recognizedString": "Do"},
                                                    {"category": "inkWord", "recognizedString": "d8"},
                                                    {"category": "inkWord", "recognizedString": "o8"}],
                                     "boundingRectangle": {"height": 25.229999542236328, "topX": 766.91998291015625,
                                                           "topY": 419.48001098632813, "width": 39.340000152587891},
                                     "category": "inkWord", "class": "leaf", "id": 6, "parentId": 3,
                                     "recognizedText": "88",
                                     "rotatedBoundingRectangle": [{"x": 766.91998291015625, "y": 426.1099853515625},
                                                                  {"x": 785.8699951171875, "y": 409.67999267578125},
                                                                  {"x": 808.82000732421875, "y": 436.17001342773438},
                                                                  {"x": 789.8599853515625, "y": 452.58999633789063}],
                                     "strokeIds": [5, 6]}, {
                                     "alternates": [{"category": "inkWord", "recognizedString": "+"},
                                                    {"category": "inkWord", "recognizedString": "A"},
                                                    {"category": "inkWord", "recognizedString": "4"},
                                                    {"category": "inkWord", "recognizedString": "H"},
                                                    {"category": "inkWord", "recognizedString": "as"},
                                                    {"category": "inkWord", "recognizedString": "at"},
                                                    {"category": "inkWord", "recognizedString": "an"},
                                                    {"category": "inkWord", "recognizedString": "am"},
                                                    {"category": "inkWord", "recognizedString": "ra"}],
                                     "boundingRectangle": {"height": 18.299999237060547, "topX": 812.9000244140625,
                                                           "topY": 397.60000610351563, "width": 25.25},
                                     "category": "inkWord", "class": "leaf", "id": 7, "parentId": 3,
                                     "recognizedText": "a",
                                     "rotatedBoundingRectangle": [{"x": 809.82000732421875, "y": 403.760009765625},
                                                                  {"x": 825.67999267578125, "y": 390.01998901367188},
                                                                  {"x": 840, "y": 406.54998779296875},
                                                                  {"x": 824.1400146484375, "y": 420.29000854492188}],
                                     "strokeIds": [7]}, {
                                     "alternates": [{"category": "inkWord", "recognizedString": "stags."},
                                                    {"category": "inkWord", "recognizedString": "stage,"},
                                                    {"category": "inkWord", "recognizedString": "stage.."},
                                                    {"category": "inkWord", "recognizedString": "sty."},
                                                    {"category": "inkWord", "recognizedString": "stage"},
                                                    {"category": "inkWord", "recognizedString": "stay."},
                                                    {"category": "inkWord", "recognizedString": "stag."},
                                                    {"category": "inkWord", "recognizedString": "stags"},
                                                    {"category": "inkWord", "recognizedString": "soap."}],
                                     "boundingRectangle": {"height": 54.759998321533203, "topX": 844.92999267578125,
                                                           "topY": 326.45001220703125, "width": 77.889999389648438},
                                     "category": "inkWord", "class": "leaf", "id": 8, "parentId": 3,
                                     "recognizedText": "stage.",
                                     "rotatedBoundingRectangle": [{"x": 828.53997802734375, "y": 357.95001220703125},
                                                                  {"x": 897.77001953125, "y": 297.98001098632813},
                                                                  {"x": 945.1099853515625, "y": 352.6300048828125},
                                                                  {"x": 875.8800048828125, "y": 412.60000610351563}],
                                     "strokeIds": [8, 9, 11, 10]}, {
                                     "alternates": [{"category": "line", "recognizedString": "the world 8 a stage."},
                                                    {"category": "line", "recognizedString": "the world 88 a stags."},
                                                    {"category": "line", "recognizedString": "the world 8 a stags."},
                                                    {"category": "line", "recognizedString": "the world 88 a stage,"},
                                                    {"category": "line", "recognizedString": "the would 88 a stage."},
                                                    {"category": "line", "recognizedString": "The world 88 a stage."},
                                                    {"category": "line", "recognizedString": "the world 8 a stage,"},
                                                    {"category": "line", "recognizedString": "the would 8 a stage."},
                                                    {"category": "line", "recognizedString": "The world 8 a stage."}],
                                     "boundingRectangle": {"height": 266.35000610351563, "topX": 598.1400146484375,
                                                           "topY": 326.45001220703125, "width": 324.67999267578125},
                                     "category": "line", "childIds": [4, 5, 6, 7, 8], "class": "container", "id": 3,
                                     "parentId": 2, "recognizedText": "the world 88 a stage.",
                                     "rotatedBoundingRectangle": [{"x": 591.07000732421875, "y": 563.65997314453125},
                                                                  {"x": 897.77001953125, "y": 297.98001098632813},
                                                                  {"x": 945.1099853515625, "y": 352.6300048828125},
                                                                  {"x": 638.41998291015625, "y": 618.30999755859375}],
                                     "strokeIds": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 10]}, {
                                     "boundingRectangle": {"height": 266.35000610351563, "topX": 598.1400146484375,
                                                           "topY": 326.45001220703125, "width": 324.67999267578125},
                                     "category": "paragraph", "childIds": [3], "class": "container", "id": 2,
                                     "parentId": 1,
                                     "rotatedBoundingRectangle": [{"x": 591.07000732421875, "y": 563.65997314453125},
                                                                  {"x": 897.77001953125, "y": 297.98001098632813},
                                                                  {"x": 945.1099853515625, "y": 352.6300048828125},
                                                                  {"x": 638.41998291015625, "y": 618.30999755859375}],
                                     "strokeIds": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 10]}, {
                                     "boundingRectangle": {"height": 266.35000610351563, "topX": 598.1400146484375,
                                                           "topY": 326.45001220703125, "width": 324.67999267578125},
                                     "category": "writingRegion", "childIds": [2], "class": "container", "id": 1,
                                     "parentId": 0,
                                     "rotatedBoundingRectangle": [{"x": 591.07000732421875, "y": 563.65997314453125},
                                                                  {"x": 897.77001953125, "y": 297.98001098632813},
                                                                  {"x": 945.1099853515625, "y": 352.6300048828125},
                                                                  {"x": 638.41998291015625, "y": 618.30999755859375}],
                                     "strokeIds": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 10]}]}


class TextViewer(FileSystemEventHandler):
    def __init__(self):
        self.font_size = 65
        self.background_color = (247, 242, 232)
        # window pos for study setup
        # os.environ['SDL_VIDEO_WINDOW_POS'] = "%d,%d" % (5300, 0)
        self.info = pg.display.Info()
        self.screen = pg.display.set_mode((700, 1400))
        self.screen_rect = self.screen.get_rect()
        self.font = pg.font.Font(None, self.font_size)
        self.clock = pg.time.Clock()
        self.color_top = (100, 60, 60)  # (208, 28, 31)
        self.color_first = (100, 100, 120)  # (75, 135, 139)
        self.color_second = (100, 100, 120)
        self.json_data = None
        self.parser = None
        self.json_path = "../tmp_out/strokes/bla.json"
        self.update_parser(self.json_path)
        self.timer = 30
        return

    def check_for_update(self, path):
        with open(path, 'r') as json_file:
            new_data = json.load(json_file)
        json_file.close()

        if self.json_data != new_data:
            self.update_parser(path)

    def update_parser(self, path):
        with open(path, 'r') as json_file:
            self.json_data = json.load(json_file)
            self.parser = InkResponseParser(self.json_data)
        json_file.close()
        return

    def clear_json(self, path):
        replace_data = {"recognitionUnits": []}
        save_json(replace_data, path)
        return

    def loop(self):
        done = False

        while not done:
            for event in pg.event.get():
                if event.type == pg.KEYDOWN:
                    if event.key == pg.K_ESCAPE:
                        done = True
                    elif event.key == pg.K_r:
                        self.clear_json(self.json_path)

            if self.timer == 0:
                self.check_for_update(self.json_path)
                self.timer = 30

            text, alternates = self.parser.get_recognized_text()

            text_render = []
            alternates_first_render = []
            alternates_second_render = []

            for line in text:
                text_render.append(self.font.render(line, True, self.color_top))

            for alternate in alternates[0]:
                alternates_first_render.append(
                    self.font.render(alternate, True, self.color_first))

            for alternate in alternates[1]:
                alternates_second_render.append(
                    self.font.render(alternate, True, self.color_first))

            self.screen.fill(self.background_color)

            sentence_step = 6 * self.font_size

            count = 0
            for line, alt_first, alt_second in zip(text_render, alternates_first_render, alternates_second_render):
                coords = (self.screen_rect.center[0], count * sentence_step + self.font_size)
                self.screen.blit(line, line.get_rect(center=coords))
                coords = (self.screen_rect.center[0], count * sentence_step + 2 * self.font_size)
                self.screen.blit(alt_first, alt_first.get_rect(center=coords))
                coords = (self.screen_rect.center[0], count * sentence_step + 3 * self.font_size)
                self.screen.blit(alt_second, alt_second.get_rect(center=coords))
                count += 1

            pg.display.flip()
            self.clock.tick(30)
            self.timer -= 1


if __name__ == '__main__':
    pg.init()

    viewer = TextViewer()
    viewer.loop()
    pg.quit()

    sys.exit()
