import numpy as np


def detect_heatmap_peaks(heatmap):
    # use argpartition to find n smallest values in negated image
    # we use flattened array indices by giving axis=None for ease of use and recreate them afterwards
    # argpart = (-(heatmap.astype('int'))).argpartition(peak_count, axis=None)
    # max_indices = argpart[:peak_count]
    max_index = np.where(heatmap == np.amax(heatmap))
    # max_indices_x, max_indices_y = np.unravel_index(max_indices, heatmap.shape)

    return max_index  # max_indices_x, max_indices_y


def get_peaks_for_heatmap_collection(heatmaps):
    peaks = []
    for i in range(heatmaps.shape[2]):
        # peaks.append(list(zip(detect_heatmap_peaks(heatmaps[:, :, i], 1))))
        peaks.append(detect_heatmap_peaks(heatmaps[:, :, i]))
    return peaks
