import numpy as np


def move_points_by_gradient(points, gradients):
    if len(points) == 0:
        return points
    gradient_lengths = np.linalg.norm(gradients, axis=-1)
    # gradient_lengths = np.dstack((gradient_lengths, gradient_lengths))
    norm_gradients = gradients / gradient_lengths[:, None]
    norm_gradients[:, 1] *= -1
    norm_gradients = np.nan_to_num(norm_gradients)
    points = points + norm_gradients  # + norm_gradients*gradient_lengths*0.1
    return points
