from dataset.augmented_heatmap_sequence import AugmentedKeypointDataGenerator
from dataset.heatmap_sequence import KeypointDataGenerator
from train.trainer import Trainer


# For one Training process
class KeypointTrainer(Trainer):
    def __init__(self, input_params, train_params):
        super().__init__(input_params, train_params)
        pass

    def _create_sequence(self, x_in, y_out, augmentation=False):
        if not augmentation:
            sequence = KeypointDataGenerator(
                x_in,
                y_out,
                self.model_config)
        else:
            sequence = AugmentedKeypointDataGenerator(
                x_in,
                y_out,
                self.model_config)
        return sequence
