import time

from numpy import random

from applications.network_utils import send_image
from imgproc.imgproc_utils import decompress_image_pil
from util.network.bidirectional_imagezmq import ZMQHubFactory

my_socket = ZMQHubFactory.get_REP("tcp://*:19858")
patch_size = 224

print("Listening...")
while True:
    before = time.perf_counter()
    # receive image, decompress
    message, data = my_socket.recv_data()
    print("Time after receive: {}".format(time.perf_counter() - before))
    image = decompress_image_pil(data)
    print("Image shape is {}".format(image.shape))
    print("Time after decompress: {}".format(time.perf_counter() - before))

    patch_keypoint = random.random((patch_size, patch_size)) * 255
    patch_bin = random.random((patch_size, patch_size)) * 255

    send_image(my_socket, patch_keypoint, "patch keypoint", compressed_send=True)
    after = time.perf_counter() - before
    print("Time for iteration: {}".format(after))
