from ast import literal_eval

import numpy as np
import pandas as pd

from util.sample_extracted_frames import get_all_image_full_paths_dataframe


def map_index(idx):
    try:
        idx = literal_eval(idx)
    except SyntaxError:
        return idx

    if type(idx) is tuple:
        return idx[1]
    else:
        return idx


if __name__ == '__main__':
    pd.set_option('display.max_colwidth', -1)
    pd.set_option('display.max_columns', None)

    all_annos = pd.read_csv('updated2_final_annos.csv', index_col=0,
                            dtype={'subject': np.int32,
                                   'task': np.int32,
                                   'frame': np.int32},
                            converters={
                                'ptip': literal_eval,
                                'ptail': literal_eval})

    # make indices consistent
    all_annos.index = all_annos.index.map(map_index)

    # update all paths
    files_df = get_all_image_full_paths_dataframe()
    files_df = files_df.set_index('img_file')
    all_annos = all_annos.fillna(files_df)

    # remove marked files
    marked_img_series = pd.read_csv('marked2_files_final_annos.txt', header=None)
    marked_idx = pd.Index(marked_img_series[0])
    all_annos = all_annos.loc[~all_annos.index.isin(marked_idx)]

    print(all_annos.head())
    print(all_annos.tail())
    print(all_annos.shape)

    all_annos.to_csv("final_consistent_annos.csv")
