from keras.utils import plot_model

from model.model_config import ModelConfig
from model.model_factory import ModelFactory
from visual.keras_filter_vis import visualize_layer


class ModelInspector:
    def __init__(self, model_weights, config_yaml):
        self.model_weights = model_weights
        self.model_config = ModelConfig(config_yaml)
        self.model = self._load_model().get_model()
        # self.model.load_weights(model_weights)
        self.model.summary()
        plot_model(self.model, to_file='model.png')
        # self._get_filters_of_layer('res5c_branch2c')
        return

    def _load_model(self):
        model_factory = ModelFactory()
        new_model = model_factory.create_model(self.model_config)
        return new_model

    def _get_filters_of_layer(self, layer_id):
        visualize_layer(self.model, layer_id, filter_range=(100, 110))
        return

    def _view_axes(self):
        pass

    def view(self):
        return


if __name__ == '__main__':
    model_weights_path = "D:\\Temp\\stalwart-keypoint-alpaca\\alpaca_subpixel_bin_model.135.h5"
    config_yaml_path = "..\\train\\params\\subpixel_binarization.yaml"

    resnet_model = resnet50.ResNet50(weights='imagenet')
    resnet_model.summary()
    plot_model(resnet_model, to_file='resnet50_model.png')

    # viewer = ModelInspector(model_weights_path, config_yaml_path)
    # viewer.view()
