import numpy as np
from keras import backend as K

from model.model_config import ModelConfig
from model.model_factory import ModelFactory

size = 100
img = np.uint8(np.random.uniform(150, 180, (size, size, 3))) / 255

# now we need a forward hook
# we want the output of layer i so that once we have the forward steps of
# the random image arrive there, we can calculate the gradient
#


model_config = ModelConfig("../train/params/subpixel_binarization.yaml")
model_factory = ModelFactory()
my_model = model_factory.create_model(model_config).get_model()

my_model.preprocess_input(img)

layer_id = 'activation_49'

get_layer_output = K.function([my_model.layers[0].input, K.learning_phase()],
                              [my_model.get_layer(layer_id).output])

my_model.get_layer(layer_id)

# output in test mode = 0
layer_output = get_layer_output([x, 0])[0]

# output in train mode = 1
layer_output = get_layer_output([x, 1])[0]
