from keras.utils import plot_model

# pydot.Dot.create(pydot.Dot())
# pydot.Dot.create(pydot.Dot(), prog=["D:/Program Files (x86)/Graphviz2.38/bin/dot.exe"])
from model.model_config import ModelConfig
from model.model_factory import ModelFactory

model_config = ModelConfig("../train/params/subpixel_keypoints.yaml")
model_factory = ModelFactory()
my_resnet = model_factory.create_model(model_config)
model = my_resnet.get_model()
plot_model(model, to_file='model.png', rankdir='LR', show_shapes=True)
